;/*--
;Copyright (c) 1992  Microsoft Corporation
;
;Module Name:
;
;    macpsmsg.h
;
;Abstract:
;
;    Definitions for MacPrint Service events.
;
;Author:
;
;    Frank Byrum (frankb@microsoft.com)
;
;Revision History:
;
;Notes:
;
;    This file is generated by the MC tool from the macprint.mc file.
;
;--*/
;
;#ifndef _MACPSMSG_
;#define _MACPSMSG_
;
;#define MACPRINT_EVENT_SOURCE	L"MacPrint"
;

SeverityNames=(Success=0x0:STATUS_SEVERITY_SUCCESS
               Informational=0x1:STATUS_SEVERITY_INFORMATIONAL
               Warning=0x2:STATUS_SEVERITY_WARNING
               Error=0x3:STATUS_SEVERITY_ERROR
              )

;
;/////////////////////////////////////////////////////////////////////////
;// MacPrint Event Categories
;/////////////////////////////////////////////////////////////////////////
;
MessageId=1 SymbolicName=EVENT_CATEGORY_INTERNAL
Language=English
System
.

MessageId=+1 SymbolicName=EVENT_CATEGORY_ADMIN
Language=English
Administrative
.

MessageId=+1 SymbolicName=EVENT_CATEGORY_USAGE
Language=English
Usage
.

MessageId=+1 SymbolicName=EVENT_CATEGORY_CONFIG
Language=English
Configuration
.

;/////////////////////////////////////////////////////////////////////////
;// Additional category for PSTODIB added by v-jimbr
;/////////////////////////////////////////////////////////////////////////
MessageId=+1 SymbolicName=EVENT_CATEGORY_PSTODIB
Language=English
TrueImage Print Processor
.

;
;/////////////////////////////////////////////////////////////////////////
;// MacPrint Service Events
;/////////////////////////////////////////////////////////////////////////
;

MessageId=2000 Severity=Informational SymbolicName=EVENT_SERVICE_STARTED
Language=English
The MacPrint Service has started.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_SERVICE_STOPPED
Language=English
The MacPrint Service has stopped.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_SERVICE_OUT_OF_RESOURCES
Language=English
Unable to allocate a system resource required for the MacPrint Service.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_SERVICE_CONTROLLER_ERROR
Language=English
The MacPrint service could not register with the Windows NT Service Controller.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_REGISTRY_ACCESS_DENIED
Language=English
The MacPrint Service does not have access to the Registry.
Use the Registry Editor to ensure that the MacPrint account has full
access to the MacPrint service key and all its subkeys.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_REGISTRY_ERROR
Language=English
The MacPrint Service was unable to access its Registry key (SYSTEM\CurrentControlSet\Services\MacPrint\Parameters).
.

MessageId=+1 Severity=Error SymbolicName=EVENT_SERVICE_OUT_OF_MEMORY
Language=English
Unable to allocate memory.  Use the System icon in Control Panel
to increase the size of the Windows NT system swap file.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_SERVICE_CREATE_FILE_ERROR
Language=English
Unable to create or open the file %1.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_SERVICE_CREATE_LOG_FILE
Language=English
MacPrint is using the log file %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_SPOOLER_NOT_RESPONDING
Language=English
The Windows NT Print System is not responding.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_PRINTER_REGISTERED
Language=English
The printer %1 is now available to the AppleTalk network.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_PRINTER_DEREGISTERED
Language=English
The printer %1 has been removed from the AppleTalk network.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_SPOOLER_JOB_REJECTED
Language=English
The Windows NT Print System has rejected a print job from a Macintosh
workstation.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_SPOOLER_WRITE_ERROR
Language=English
An error occurred sending a print job to the Windows NT Print System.
The print job has been canceled.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_APPLETALK_PRINTER_STOPPED
Language=English
An error occurred on the AppleTalk network, which made a Windows NT
printer no longer available to Macintosh users. Try restarting the
AppleTalk Protocol Device using the Devices icon in Control Panel.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_APPLETALK_JOB_STOPPED
Language=English
An error occurred on the AppleTalk network, which caused a Macintosh print
job to be canceled. Try restarting the AppleTalk Protocol
using the Devices icon in Control Panel.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_JOB_INVALID
Language=English
The print job was canceled because it was not generated using the
standard LaserWriter driver. The print job must conform  to the
Adobe's Document Structuring Conventions Version 2.0, available
when the LaserWriter driver is used.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_DOWNLEVEL_DRIVER
Language=English
A Macintosh workstation has submitted a job using a version of the
LaserWriter driver that is not supported. This workstation should
be upgraded to Apple system software version 6.07 or above.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_DSC_SYNTAX_ERROR
Language=English
A Macintosh workstation submitted a job with Adobe Document Structuring
Convention (newer than v2.0) comments that could not be processed.  The job from %1 was
canceled.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_SYSTEM_ERROR
Language=English
An internal error occurred while MacPrint service was trying to log an event. The error returned is %1.
.

MessageId=+1 Severity=Informational SymbolicName=STRING_SPOOLER_ACTIVE
Language=English
status: Spooling to print server "%1" ...
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_MESSAGE_NOT_FOUND
Language=English
No message text was found for this error code.
.

;////////////////////////////////////////////////////////////////////////////
;//  Additional messages added for PSTODIB component by Jim Bratsanos (v-jimbr)
;////////////////////////////////////////////////////////////////////////////
MessageId=4000 Severity=Error SymbolicName=EVENT_PSTODIB_INIT_ACCESS
Language=English
The TrueImage Interpreter initialization failed.
(Document Name: %1)
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_JOB_ACCESS
Language=English
TrueImage Interpreter - internal error occurred during job processing. The job will not print.
(Document Name: %1)
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_STRING_SEQ
Language=English
TrueImage Interpreter - internal error occurred during string processing. The job will not print.
(Document Name: %1)
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_FRAME_ALLOC
Language=English
A TrueImage Interpreter frame buffer memory allocation failed.
(Document Name: %1)
.
MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_UNDEFINED_ERROR
Language=English
A TrueImage Interpreter error occurred for which no error string is defined.
(Document Name: %1), Error Code: %2
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_LOG_INVALID_HANDLE
Language=English
The handle passed to the TrueImage Interpreter loggin routine is invalid.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_CANNOT_CREATE_DC
Language=English
The TrueImage Interpreter was unable to create a required device context.
The error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_CANNOT_DO_STARTDOC
Language=English
The TrueImage Interpreter was unable to start printing the document.
The error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_GETDEFDEVMODE_FAIL
Language=English
The TrueImage Interpreter was unable to retrieve the default printer
characteristics. The error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_MEM_ALLOC_FAILURE
Language=English
The TrueImage Interpreter was unable to allocate memory.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_ERROR_STARTPG_FAIL
Language=English
The TrueImage Interpreter was unable to generate the Error Page. The
error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_GET_DATA_FAILED
Language=English
The TrueImage Interpreter was unable to retrieve data from the print
spooler. The error code returned from the system was %1.
.


MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_FAIL_IMAGE
Language=English
The TrueImage Interpreter was unable to render the print job.
The error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_INIT_FAILED
Language=English
The TrueImage Interpreter was unable to initialize the required information to begin processing the job.
The error code returned from the system was %1.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_FONTQUERYFAIL
Language=English
The TrueImage Interpreter was unable to query the font list correctly to begin processing the job.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_INTERNAL_FONT
Language=English
The TrueImage Interpreter has reached its limit for internal fonts. No more
fonts can be defined.
.

MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_MEM_FAIL
Language=English
The TrueImage Interpreter failed to allocate memory required to process a job. The job will not print.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_JOB_COMPLETED
Language=English
A Macintosh workstation has submitted a print job.  The Macintosh Owner Name
is  %1.
.

MessageId=+1 Severity=Informational SymbolicName=EVENT_UNKNOWNJOB_COMPLETED
Language=English
A Macintosh workstation has submitted a print job. The Macintosh Owner
Name is not available.
.

MessageId=+1 Severity=Warning SymbolicName=EVENT_PSTODIB_RESETDC_FAILED
Language=English
The TrueImage Interpreter was unable to reset page-level information, such
as paper size or number of copies. The job printing may not be correct.
The error code returned from the system was %1.
.
MessageId=+1 Severity=Warning SymbolicName=EVENT_PSTODIB_SETPRIORITY_FAILED
Language=English
The TrueImage Interpreter was unable to set its priority correctly.
The error code returned from the system was %1.
.
MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_STARTPSEXE_FAILED
Language=English
The TrueImage Interpreter process was unable to start succesfully.
The error code returned from the system was %1.
.
MessageId=+1 Severity=Error SymbolicName=EVENT_PSTODIB_SECURITY_PROBLEM
Language=English
The TrueImage Interpreter was unable to set the correct security privilege
and cannot print the job. The error code returned from the system was %1.
.
MessageId=+1 Severity=Informational SymbolicName=STRING_SPOOLER_IDLE
Language=English
status: idle
.
MessageId=+1 Severity=Error SymbolicName=EVENT_NAME_REGISTRATION_FAILED
Language=English
The printer %1 could not be registered on the AppleTalk network.
.
MessageId=+1 Severity=Error SymbolicName=EVENT_NAME_DUPNAME_EXISTS
Language=English
The printer %1 could not be registered because another printer by the same name
already exists on this AppleTalk network.
.

;
;#endif // _MACPSMSG_
;

