;/*++ BUILD Version: 0001    // Increment this if a change has global effects
;
;Copyright (c) 1994  Microsoft Corporation
;
;Module Name:
;
;    dhcpmsg.h
;
;Abstract:
;
;    Definitions for DHCP messages.
;
;Author:
;
;    Madan Appiah (madana)  10-Sep-1993
;    Manny Weiser 8-Dec-1992
;
;Revision History:
;
;Notes:
;
;    This file is generated by the MC tool from the dhcpmsg.mc file.
;
;    ?? NOTE : These message should go into winerror.h, until then use a
;    error code range which is not used by the system.
;
;--*/
;
;#ifndef _DHCPMESSAGE_
;#define _DHCPMESSAGE_
;

;//
;//  20000 - 20099   Reserved for DHCP server service specific errors.
;//

MessageId=20000 SymbolicName=ERROR_DHCP_REGISTRY_INIT_FAILED
Language=English
The DHCP server initialization parameters are invalid.
.

MessageId=20001 SymbolicName=ERROR_DHCP_DATABASE_INIT_FAILED
Language=English
The DHCP server was unable to open the DHCP client database.
.

MessageId=20002 SymbolicName=ERROR_DHCP_RPC_INIT_FAILED
Language=English
The DHCP server was unable to start as an RPC server.
.

MessageId=20003 SymbolicName=ERROR_DHCP_NETWORK_INIT_FAILED
Language=English
The DHCP server was unable establish a sockets connection.
.

MessageId=20004 SymbolicName=ERROR_DHCP_SUBNET_EXITS
Language=English
The specified Subnet already exists.
.

MessageId=20005 SymbolicName=ERROR_DHCP_SUBNET_NOT_PRESENT;
Language=English
The specified Subnet does not exist.
.

MessageId=20006 SymbolicName=ERROR_DHCP_PRIMARY_NOT_FOUND
Language=English
The primary host information for the specified subnet was not found.
.

MessageId=20007 SymbolicName=ERROR_DHCP_ELEMENT_CANT_REMOVE
Language=English
The specified DHCP element cannot be removed because it has been used.
.

MessageId=20009 SymbolicName=ERROR_DHCP_OPTION_EXITS
Language=English
The specified option already exists.
.

MessageId=20010 SymbolicName=ERROR_DHCP_OPTION_NOT_PRESENT;
Language=English
The specified option does not exist.
.

MessageId=20011 SymbolicName=ERROR_DHCP_ADDRESS_NOT_AVAILABLE;
Language=English
The specified address is not available.
.

MessageId=20012 SymbolicName=ERROR_DHCP_RANGE_FULL;
Language=English
The specified Range is full.
.

MessageId=20013 SymbolicName=ERROR_DHCP_JET_ERROR;
Language=English
An error occurred while accessing the DHCP database; Look at the
DHCP server event log for more information.
.

MessageId=20014 SymbolicName=ERROR_DHCP_CLIENT_EXISTS;
Language=English
The specified Client already exists in the database.
.

MessageId=20015 SymbolicName=ERROR_DHCP_INVALID_DHCP_MESSAGE;
Language=English
The DHCP server received an invalid message.
.

MessageId=20016 SymbolicName=ERROR_DHCP_INVALID_DHCP_CLIENT;
Language=English
The DHCP server received a message from an invalid client.
.

MessageId=20017 SymbolicName=ERROR_DHCP_SERVICE_PAUSED;
Language=English
The DHCP server service is paused.
.

MessageId=20018 SymbolicName=ERROR_DHCP_NOT_RESERVED_CLIENT;
Language=English
The specified client is not a reserved client.
.

MessageId=20019 SymbolicName=ERROR_DHCP_RESERVED_CLIENT;
Language=English
The specified client is a reserved client.
.

MessageId=20020 SymbolicName=ERROR_DHCP_RANGE_TOO_SMALL;
Language=English
The specified IpRange is too small.
.

MessageId=20021 SymbolicName=ERROR_DHCP_IPRANGE_EXITS;
Language=English
The specified IpRange already exists.
.

MessageId=20022 SymbolicName=ERROR_DHCP_RESERVEDIP_EXITS;
Language=English
The specified IP address is already used by another client.
.

MessageId=20023 SymbolicName=ERROR_DHCP_INVALID_RANGE;
Language=English
The specified range either overlaps with an already existing range or is
invalid.
.

MessageId=20024 SymbolicName=ERROR_DHCP_RANGE_EXTENDED;
Language=English
The specified range is extension of an already existing range.
.

MessageId=20025 SymbolicName=ERROR_EXTEND_TOO_SMALL;
Language=English
Specified extension is too small. Extend the range in integral of 32
addresses.
.

MessageId=20026 SymbolicName=WARNING_EXTENDED_LESS;
Language=English
The range is extended less than the specified backward extension.
Extend the range in integral of 32 addresses.
.

MessageId=20027 SymbolicName=ERROR_DHCP_JET_CONV_REQUIRED;
Language=English
DHCP database needs to be upgraded to a newer format; Look at the
DHCP server event log for more information.
.

MessageId=20028 SymbolicName=ERROR_SERVER_INVALID_BOOT_FILE_TABLE
Language=English
The format of the BOOTP file table is incorrect.  The correct format is:
<requested boot file name1>,<boot file server name1>,<boot file name1>
<requested boot file name2>,<boot file server name2>,<boot file name2>
etc...
.

MessageId=20029 SymbolicName=ERROR_SERVER_UNKNOWN_BOOT_FILE_NAME
Language=English
.

MessageId=20030 SymbolicName=ERROR_DHCP_SUPER_SCOPE_NAME_TOO_LONG;
Language=English
The specified superscope name is too long.
.

MessageId=20032 SymbolicName=ERROR_DHCP_IP_ADDRESS_IN_USE;
Language=English
This IP address is already in use.
.

MessageId=20033 SymbolicName=ERROR_DHCP_LOG_FILE_PATH_TOO_LONG
Language=English
The DHCP audit log file path is too long.
.

MessageId=20034 SymbolicName=ERROR_DHCP_UNSUPPORTED_CLIENT
Language=English
The DHCP Server received a request for a valid IP address that is not administered by this server.
.


;//
;//  1000 - 1099   Reserved for DHCP server events.
;//

MessageId=1000 SymbolicName=EVENT_SERVER_UNKNOWN_OPTION
Language=English
The DHCP Server received an unknown option %1 of length %2. The raw option
data is given below.
.

MessageId=1001 SymbolicName=EVENT_SERVER_FAILED_REGISTER_SC
Language=English
The DHCP Server failed to register with Service Controller. The
following error occurred: %n%1.
.

MessageId=1002 SymbolicName=EVENT_SERVER_INIT_DATA_FAILED
Language=English
The DHCP server failed to initialize its global data. The following
error occurred: %n%1
.

MessageId=1003 SymbolicName=EVENT_SERVER_INIT_REGISTRY_FAILED
Language=English
The DHCP server failed to initialize its registry data. The following
error occurred: %n%1
.

MessageId=1004 SymbolicName=EVENT_SERVER_INIT_DATABASE_FAILED
Language=English
The DHCP server failed to initialize the database. The following
error occurred: %n%1
.

MessageId=1005 SymbolicName=EVENT_SERVER_INIT_WINSOCK_FAILED
Language=English
The DHCP server failed to initialize Winsock startup. The following
error occurred: %n%1
.

MessageId=1006 SymbolicName=EVENT_SERVER_INIT_RPC_FAILED
Language=English
The DHCP Server Failed to start the RPC server. The following error
occurred : %n%1
.

MessageId=1007 SymbolicName=EVENT_SERVER_INIT_SOCK_FAILED
Language=English
The DHCP server failed to initialize winsock data. The following
error occurred: %n%1
.

MessageId=1008 SymbolicName=EVENT_SERVER_SHUTDOWN
Language=English
The DHCP server is shutting down due to the following error: %n%1
.

MessageId=1009 SymbolicName=EVENT_SERVER_CLIENT_CLEANUP
Language=English
The DHCP server encountered the following error when cleaning up the
pending user records: %n%1
.

MessageId=1010 SymbolicName=EVENT_SERVER_DATABASE_CLEANUP
Language=English
The DHCP server encountered the following error when cleaning up the user
database: %n%1
.

MessageId=1011 SymbolicName=EVENT_SERVER_LEASE_NACK
Language=English
The DHCP server issued a NACK to the client (%2) for the address (%1)
request.
.

MessageId=1012 SymbolicName=EVENT_SERVER_LEASE_DECLINED
Language=English
The DHCP Client (%2) declined the address (%1).
.

MessageId=1013 SymbolicName=EVENT_SERVER_LEASE_RELEASE
Language=English
The DHCP Client (%2) released the address (%1).
.

MessageId=1014 SymbolicName=EVENT_SERVER_JET_ERROR
Language=English
The JET Database call returned the following Error : %1.
.

MessageId=1015 SymbolicName=EVENT_SERVER_JET_WARNING
Language=English
The JET Database call returned the following Warning : %1.
.

MessageId=1016 SymbolicName=EVENT_SERVER_DATABASE_BACKUP
Language=English
The DHCP server encountered the following error when backing up the
user database: %n%1
.

MessageId=1017 SymbolicName=EVENT_SERVER_CONFIG_BACKUP
Language=English
The DHCP server encountered the following error when backing up the
registry configuration: %n%1
.

MessageId=1018 SymbolicName=EVENT_SERVER_DATABASE_RESTORE_FAILED
Language=English
The DHCP server failed to restore the database. The following
error occurred: %n%1
.

MessageId=1019 SymbolicName=EVENT_SERVER_CONFIG_RESTORE_FAILED
Language=English
The DHCP server failed to restore the dhcp registry configuration. The
following error occurred: %n%1
.
MessageId=1020 SymbolicName=EVENT_SERVER_LOW_ADDRESS_WARNING
Language=English
Scope %1 is %2 percent utilized with only %3 IP addresses remaining.
.

MessageId=1021 SymbolicName=EVENT_SERVER_LOAD_JET_FAILED
Language=English
The DHCP server could not load jet database library successfully.
.

MessageId=1022 SymbolicName=EVENT_SERVER_JET_CONV_REQUIRED
Language=English
The DHCP server could not initialize the database. If this service
was started the first time after the upgrade from NT3.51 or prior
release, you need to run upg351db.exe utility on the dhcp database
to convert it to the new and improved database format. Restart the
DHCP server after you have done that.
.

MessageId=1023 SymbolicName=EVENT_SERVER_JET_CONV_IN_PROGRESS
Language=English
The DHCP server will now terminate because the existent database
needs conversion to NT SUR format.  It has initiated the conversion
via a process(jetconv).   Do not reboot or kill the jetconv process.
The conversion may take anywhere from few seconds to 10 minutes
(depending on the size of the database). Please terminate DHCP now by
clicking on OK. This is required for the database conversion to succeed.

NOTE: THE DHCP WILL BE RESTARTED AUTOMATICALLY WHEN THE CONVERSION
IS COMPLETED. TO CHECK THE STATE OF THE CONVERSION, PLEASE CHECK THE
APPLICATION EVENT LOG OF JETCONV PROCESS.
.

MessageId=1024 SymbolicName=EVENT_SERVER_INIT_AND_READY
Language=English
The DHCP server has initialized and is ready
.

MessageId=1025 SymbolicName=EVENT_SERVER_BOOT_FILE_TABLE
Language=English
The DHCP server was unable to read the BOOTP file table from the
registry.  The DHCP server will be unable to respond to BOOTP requests
that specify the boot file name.
.
MessageId=1026 SymbolicName=EVENT_SERVER_BOOT_FILE_NAME
Language=English
The DHCP server was unable to read the global BOOTP file name from the
registry.
.

MessageId=1027 SymbolicName=EVENT_SERVER_AUDIT_LOG_APPEND_FAILED
Language=English
The audit log file cannot be appended.
.

MessageId=1028 SymbolicName=EVENT_SERVER_INIT_AUDIT_LOG_FAILED
Language=English
The DHCP server failed to initialize the audit log. The following
error occurred: %n%1
.

MessageId=1029 SymbolicName=EVENT_SERVER_PING_FAILED
Language=English
The DHCP server was unable to ping for a new IP address. The address was leased to the client.
.

;//
;// Audit log strings
;//

;//
;// BEGIN: these strings should be <= 10 characters in length
;//

MessageId=1030 SymbolicName=DHCP_IP_LOG_ASSIGN_NAME
Language=English
Assign%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_BOOTP_NAME
Language=English
Bootp%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_RENEW_NAME
Language=English
Renew%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_RELEASE_NAME
Language=English
Release%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_CONFLICT_NAME
Language=English
Conflict%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_RANGE_FULL_NAME
Language=English
Scope Full%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_START_NAME
Language=English
Started%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_STOP_NAME
Language=English
Stopped%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_DISK_SPACE_LOW_NAME
Language=English
Paused%0
.


MessageId=+1 SymbolicName=DHCP_IP_LOG_FILE_NAME
Language=English
dhcpsrv.log%0
.

MessageId=+1 SymbolicName=DHCP_BAD_ADDRESS_NAME
Language=English
BAD_ADDRESS%0
.

MessageId=+1 SymbolicName=DHCP_BAD_ADDRESS_INFO
Language=English
This address is already in use%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_NACK_NAME
Language=English
NAck%0
.

MessageId=+1 SymbolicName=DHCP_IP_LOG_HEADER
Language=English
                     Microsoft DHCP Server Activity Log

Event ID  Meaning
00        The log was started.
01        The log was stopped.
02        The log was temporarily paused due to low disk space.
10        A new IP address was leased to a client.
11        A lease was renewed by a client.
12        A lease was released by a client.
13        An IP address was found to be in use on the network.
14        A lease request could not be satisfied because the scope's
          address pool was exhausted.
15        A lease was denied.
20        A BOOTP address was leased to a client.


ID Date,Time,Description,IP Address,Host Name,MAC Address
.


;//
;// END
;//

;#endif // _DHCPMESSAGE_


