#include <uimsg.h>
#include <uihelp.h>

/*
 *   The following numbers are required by the BLT DLL, LMUICOMN.DLL
 *   The numeric resource range for the NCPA is 6000-6999.
 *
 */

#define IDD_DLG_NM_NCPA             6200
#define IDD_DLG_NM_ABOUT            6210
#define IDD_DLG_NM_FOUND            6220
#define IDD_DLG_NM_FACTS            6230
#define IDD_DLG_NM_BINDINGS         6240
#define IDD_DLG_NM_PASSWORD         6250
#define IDD_DLG_NM_COMPUTING        6260
#define IDD_DLG_NM_QUERY            6270
#define IDD_DLG_NM_ORDER            6280
#define IDD_DLG_NAME_WINNT          6310
#define IDD_DLG_NAME_LANNT          6330
#define IDD_DLG_NAME_JOIN_DOM       6340
#define IDD_DLG_NAME_LOGON_DOM      6350
#define IDD_DLG_NAME_LOGON_ICON     6360
#define IDD_DLG_NAME_ACCT_PW        6370
#define IDD_DLG_NAME_OFFSCREEN      6410
#define IDD_DLG_COMPUTERNAME        6415
#define IDD_DLG_NM_LANANUM          6420
#define IDD_DLG_NM_DETECT           6425
#define IDD_DLG_NM_BROWSER          6430
#define IDD_DLG_LANNT_DOMN_RENAME   6445
#define IDD_DLG_NM_GETBUS           6450
#define IDD_DLG_NM_BDCREPL          6455
#define IDD_DLG_REBOOT              6456

#define ICO_NCPA_ICON               6901
#define ICO_SETUP_ICON              6902
#define ICO_PROGRESS                6909
#define ICO_PROGRESS_0              6910
#define ICO_PROGRESS_1              6911
#define ICO_PROGRESS_2              6912
#define ICO_PROGRESS_3              6913
#define ICO_PROGRESS_4              6914
#define ICO_PROGRESS_5              6915
#define ICO_PROGRESS_6              6916
#define ICO_PROGRESS_7              6917
#define ICO_PROGRESS_8              6918
#define ICO_PROGRESS_9              6919
#define ICO_PROGRESS_10             6920
#define ICO_PROGRESS_11             6921
#define NUM_PROGRESS_ICONS          12

#define DMID_OPEN                   6843                /* Open connection bitmap */
#define DMID_CLSD                   6844                /* Closed connection bitmap */

#define DMID_UP_ARROW               6845
#define DMID_UP_ARROW_INV           6846
#define DMID_UP_ARROW_DIS           6847
#define DMID_DOWN_ARROW             6848
#define DMID_DOWN_ARROW_INV         6849
#define DMID_DOWN_ARROW_DIS         6850

 /*   Menu item numbers for the test application   */

#define IDM_FILE_EXIT               110
#define IDM_ABOUT                   100
#define IDM_RUN_TEST0               200
#define IDM_RUN_TEST1               201
#define IDM_RUN_TEST2               202
#define IDM_RUN_TEST3               203
#define IDM_RUN_TEST4               204
#define IDM_RUN_TEST5               205
#define IDM_RUN_TEST6               206
#define IDM_RUN_DETECT              207
#define IDM_RUN_INSTALL             210
#define IDM_INSTALL_CFG             301
#define IDM_INSTALL_NET             302
#define IDM_INSTALL_DOMAIN          303
#define IDM_STOP_NETWORK            304

#define IDC_EDIT_QUERY               1001
#define IDC_EDIT_ANSWER              1002
#define IDC_BUTN_REG                 1003

#define IDC_MAIN_CHK_SHARE           1010
#define IDC_MAIN_CHK_INCLUDE         1011
#define IDC_MAIN_CHK_SETTIME         1012
#define IDC_MAIN_EDIT_SETTIME        1013

#define IDC_MAIN_DOMAIN_NAME         1020
#define IDC_MAIN_COMPUTER_NAME       1021
#define IDC_MAIN_COMMENT             1022
#define IDC_MAIN_OVERLAY             1023
#define IDC_MAIN_SLT_DOMAIN          1024
#define IDC_MAIN_SLT_COMPUTER        1025
#define IDC_MAIN_SLT_COMMENT         1026

#define IDC_MAIN_BUTN_ADVANCED       1030
#define IDC_MAIN_BUTN_BINDINGS       1031
#define IDC_MAIN_BUTN_DOMAIN         1032
#define IDC_MAIN_BUTN_CONFIGURE      1033
#define IDC_MAIN_BUTN_ADD            1034
#define IDC_MAIN_BUTN_ADD_CARD       1035
#define IDC_MAIN_BUTN_REMOVE         1036
#define IDC_MAIN_BUTN_SETUP          1037
#define IDC_MAIN_BUTN_PROVIDERS      1038
#define IDC_MAIN_BUTN_UPDATE         1039
#define IDC_MAIN_BUTN_COMPUTERNAME   1040

#define IDC_MAIN_LIST_PROTOCOLS      1050
#define IDC_MAIN_LIST_CARDS          1051
#define IDC_MAIN_EDIT_DESCRIPTION    1052

#define IDC_MAIN_BOUNDARY            1060
#define IDC_MAIN_STATIC_DESC         1061

/*  Define CID for non-existent control; used for signalling  */

#define IDC_MAIN_DLG_MESSAGE         550

#define IDC_BIND_COMBO_COMPONENT     1070
#define IDC_BIND_LIST                1071
#define IDC_BIND_LIST_COL1           1072
#define IDC_BIND_LIST_COL2           1073
#define IDC_BIND_LIST_COL3           1074
/*  Skipped one after column header -- just in case  */
#define IDC_BIND_BUTN_ENABLE         1077
#define IDC_BIND_BUTN_DISABLE        1078
#define IDC_BIND_SCROLL_BAR          1079
#define IDC_BIND_BUTN_UP             1080
#define IDC_BIND_BUTN_DOWN           1081

#define IDC_FOUND_TITLE              1090
#define IDC_FOUND_LIST               1091

#define IDC_COMPUTE_METER            1100
#define IDC_COMPUTE_DESC             1101

#define IDC_FACTS_EDIT               1110

#define IDC_ADDCARD_LIST             1120
#define IDC_ADDCARD_BUTN_ADD         1121

#define IDC_INSTPROD_BUTN_BROWSE     1130
#define IDC_INSTPROD_EDIT_PATH       1131
#define IDC_INSTPROD_LIST            1132

#define IDC_INSTCARD_BUTN_BROWSE     1140
#define IDC_INSTCARD_SLT_COMMENT     1141
#define IDC_INSTCARD_SLE_FILENAME    1142


#define IDC_DOMAIN_EDIT_COMPNAME     1150
#define IDC_DOMAIN_GRP_ROLE          1151
  /* The next two control IDs must be sequential */
#define IDC_DOMAIN_RAD_MEMBER        1152
#define IDC_DOMAIN_RAD_ALONE         1153
#define IDC_DOMAIN_EDIT_DOMAIN       1154

#define IDC_PASSWORD_SLT_COMPNAME    1160
#define IDC_PASSWORD_EDIT_INITIAL    1161
#define IDC_PASSWORD_EDIT_CONFIRM    1162

#define IDC_UP                       1170
#define IDC_DOWN                     1171
#define IDC_ORDER_LISTBOX            1172

#define IDC_GROUPBOX                 1173
#define IDC_SLE                      1174
#define IDC_LISTBOX                  1175

#define IDC_REMAP_OK                 1176
#define IDC_PRVD_COMBO_COMPONENT     1177
   /*
       Control ID for first visible help text on dialog
       If help is NOT being shown, all area lower than the upper border
       of this control will be truncated.
    */

#define IDC_SETUP_HELP_TEXT         1180

#define IDC_DOMWIN_SLT_CNAME        1190
#define IDC_DOMWIN_EDIT_DNAME       1191
#define IDC_DOMWIN_EDIT_WNAME       1192
#define IDC_DOMWIN_RBUTN_DOMAIN     1193
#define IDC_DOMWIN_RBUTN_WORKGROUP  1194
#define IDC_DOMWIN_EDIT_USER_NAME   1196
#define IDC_DOMWIN_EDIT_USER_PW     1197
#define IDC_DOMWIN_USEADMINHELP     1198
#define IDC_DOMWIN_SLT_USERNAME     1199
#define IDC_DOMWIN_SLT_USER_PASS    1200
#define IDC_DOMWIN_CHECKBOX_USE_ADMIN 1202

#define IDC_DOMLMN_SLT_CNAME        1210
#define IDC_DOMLMN_EDIT_DNAME       1211
#define IDC_DOMLMN_EDIT_BNAME       1212
#define IDC_DOMLMN_RBUTN_DOMAIN     1213
#define IDC_DOMLMN_RBUTN_BACKUP     1214
#define IDC_DOMLMN_EDIT_USER_NAME   1216
#define IDC_DOMLMN_EDIT_USER_PW     1217
#define IDC_DOMLMN_SLT_PDCNAME      1218
#define IDC_DOMLMN_RBUTN_USER_NAME  1219
#define IDC_DOMLMN_EDIT_PNAME       1220
#define IDC_DOMLMN_GRP_PASSWORD     1221
#define IDC_DOMLMN_SLT_USER_PASS    1222
#define IDC_DOMLMN_SLT_USERNAME     1223

#define IDC_JOIN_ICON               1230
#define IDC_JOIN_EDIT_DNAME         1231
#define IDC_JOIN_RBUTN_AGAIN        1232
#define IDC_JOIN_RBUTN_CREATE       1233
#define IDC_JOIN_RBUTN_NAME         1234
#define IDC_JOIN_EDIT_DCNAME        1235

#define IDC_LOGON_EDIT_USERNAME     1240
#define IDC_LOGON_EDIT_PASSWORD     1241
#define IDC_LOGON_ICON              1242

#define IDC_DOMACCT_ICON            1250
#define IDC_DOMACCT_PASSWORD        1251

#define IDC_OFFSCREEN_INF_NAME      1260
#define IDC_OFFSCREEN_ICON1         1261
#define IDC_OFFSCREEN_ICON2         1262
#define IDC_OFFSCREEN_COMMENT       1263

#define IDC_COMPUTERNAME_EDIT       1270

#define IDC_DETECT_BUTN_NEXT        1280
#define IDC_DETECT_BUTN_VERIFY      1281
#define IDC_DETECT_BUTN_PARAM       1282
#define IDC_DETECT_LIST_CARDS       1283
#define IDC_DETECT_LIST_FOUND       1284
#define IDC_DETECT_EDIT_PARAM       1285

#define IDC_DOMLMN_RENAME_EDIT_NAME 1300
#define IDC_DOMLMN_RENAME_SLT_OLD_NAME 1301

// Netbios stuff, from netbios.h

#define IDC_ROUTE       2200
#define IDC_LANANUM     2201

// browser stuff
#define IDC_MASTER              2210
#define IDC_MAINTAIN_LIST       2211



// from order.h
#define SEARCH_ORDER                2300
#define IDC_HEADER                  2301
#define IDC_ORIG_LISTBOX            2302
#define IDC_ADD                     2304
#define IDC_REMOVE                  2305

// Get Bus Type dialog
#define IDC_CARD_NAME               2600
#define IDC_BUS_TYPE                2610
#define IDC_BUS_NUM                 2620


#define DMID_USER                   200




/*   Real NCPA error codes start at IDS_UI_NCPA_BASE */

#define IDS_NCPA_BNDR_NO_SVCS           IDS_UI_NCPA_BASE+1
#define IDS_NCPA_BNDR_NO_ADAP           IDS_UI_NCPA_BASE+2
#define IDS_NCPA_BNDR_NO_PROD           IDS_UI_NCPA_BASE+3
#define IDS_NCPA_BNDR_ADAP_ZERO       IDS_UI_NCPA_BASE+4
#define IDS_NCPA_BNDR_CNSLT_BASE      IDS_UI_NCPA_BASE+5
#define IDS_NCPA_BNDR_CNSLT_FACT      IDS_UI_NCPA_BASE+6
#define IDS_NCPA_BNDR_QURY_FAIL       IDS_UI_NCPA_BASE+7
#define IDS_NCPA_BNDR_QURY_PARSE_FAIL IDS_UI_NCPA_BASE+8
#define IDS_NCPA_BNDR_LOAD_FMT_ERR    IDS_UI_NCPA_BASE+9
#define IDS_NCPA_BNDR_LOAD_REG_ERR    IDS_UI_NCPA_BASE+10
#define IDS_NCPA_BNDR_CNVRT_FACT      IDS_UI_NCPA_BASE+11
#define IDS_NCPA_BNDR_ASSOCIATE       IDS_UI_NCPA_BASE+12

#define IDS_NCPA_BIND_INIT_FAIL       IDS_UI_NCPA_BASE+20
#define IDS_NCPA_BIND_BIND_FAIL       IDS_UI_NCPA_BASE+21

#define IDS_NCPA_REG_FMT_NO_HOME      IDS_UI_NCPA_BASE+30
#define IDS_NCPA_REG_FMT_NO_RULEFILE  IDS_UI_NCPA_BASE+31
#define IDS_NCPA_REG_FMT_NO_BINDFILE  IDS_UI_NCPA_BASE+32

#define IDS_NCPA_SETUP_FILE_DESC1     IDS_UI_NCPA_BASE+40
#define IDS_NCPA_SETUP_FILE_DESC2     IDS_UI_NCPA_BASE+41
#define IDS_NCPA_SETUP_FILE_DESC3     IDS_UI_NCPA_BASE+42
#define IDS_NCPA_SETUP_FILE_TITLE     IDS_UI_NCPA_BASE+43

#define IDS_NCPA_SETUP_COMP_TITLE     IDS_UI_NCPA_BASE+50

#define IDS_BSTAGE_RESET              IDS_UI_NCPA_BASE+51
#define IDS_BSTAGE_ADAPTERS           IDS_UI_NCPA_BASE+52
#define IDS_BSTAGE_SERVICES           IDS_UI_NCPA_BASE+53
#define IDS_BSTAGE_PRODUCTS           IDS_UI_NCPA_BASE+54
#define IDS_BSTAGE_CVT_FACTS          IDS_UI_NCPA_BASE+55
#define IDS_BSTAGE_CNSLT_RULES        IDS_UI_NCPA_BASE+56
#define IDS_BSTAGE_CNSLT_FACTS        IDS_UI_NCPA_BASE+57
#define IDS_BSTAGE_QUERY              IDS_UI_NCPA_BASE+58
#define IDS_BSTAGE_BINDINGS           IDS_UI_NCPA_BASE+59

#define IDS_NCPA_REG_VALUE_NOT_FOUND  IDS_UI_NCPA_BASE+70
#define IDS_NCPA_REG_KEY_NOT_FOUND    IDS_UI_NCPA_BASE+71
#define IDS_NCPA_SETUP_FAILED         IDS_UI_NCPA_BASE+72
#define IDS_NCPA_RESOURCE_NOT_FOUND   IDS_UI_NCPA_BASE+73
#define IDS_NCPA_SETUP_CANCELLED      IDS_UI_NCPA_BASE+74
#define IDS_NCPA_DOMMGR_PARMS         IDS_UI_NCPA_BASE+75

#define IDS_DOMAIN_LEAVE_WARNING      IDS_UI_NCPA_BASE+77

#define IDS_PASSWORD_DONT_MATCH1      IDS_UI_NCPA_BASE+80
#define IDS_PASSWORD_DONT_MATCH2      IDS_UI_NCPA_BASE+81

#define IDS_DOMAIN_EMPTY_DOMAIN       IDS_UI_NCPA_BASE+82

#define IDS_DOMAIN_CHANGE_WARNING     IDS_UI_NCPA_BASE+83
#define IDS_DOMAIN_RENAME_WARNING1    IDS_UI_NCPA_BASE+86
#define IDS_DOMAIN_RENAME_WARNING2    IDS_UI_NCPA_BASE+87
#define IDS_DOMAIN_LABEL              IDS_UI_NCPA_BASE+88
#define IDS_WORKGROUP_LABEL           IDS_UI_NCPA_BASE+89

#define IDS_NCPA_REPLACE_1            IDS_UI_NCPA_BASE+90
#define IDS_NCPA_REPLACE_2            IDS_UI_NCPA_BASE+91

#define IDS_COMPNAME_CHANGE_WARNING1  IDS_UI_NCPA_BASE+92
#define IDS_COMPNAME_CHANGE_WARNING2  IDS_UI_NCPA_BASE+93
#define IDS_COMPNAME_CHANGE_WARNING3  IDS_UI_NCPA_BASE+94
#define IDS_COMPNAME_CHANGE_WARNING4  IDS_UI_NCPA_BASE+95

#define IDS_WINREG_ERROR_BASE         IDS_UI_NCPA_BASE+100
#define IDS_WINREG_NO_ERROR           IDS_WINREG_ERROR_BASE+0
#define IDS_WINREG_BADDB              IDS_WINREG_ERROR_BASE+1
#define IDS_WINREG_BADKEY             IDS_WINREG_ERROR_BASE+2
#define IDS_WINREG_CANTOPEN           IDS_WINREG_ERROR_BASE+3
#define IDS_WINREG_CANTREAD           IDS_WINREG_ERROR_BASE+4
#define IDS_WINREG_CANTWRITE          IDS_WINREG_ERROR_BASE+5
#define IDS_WINREG_OUTOFMEMORY        IDS_WINREG_ERROR_BASE+6

#define IDS_FOUND_REG_FAILURE           IDS_UI_NCPA_BASE+150
#define IDS_FOUND_REG_NO_SVCS           IDS_UI_NCPA_BASE+151
#define IDS_FOUND_TITLE_SVCS            IDS_UI_NCPA_BASE+152
#define IDS_FOUND_TITLE_ADAP            IDS_UI_NCPA_BASE+153
#define IDS_FOUND_TITLE_PROD            IDS_UI_NCPA_BASE+154
#define IDS_FOUND_REG_NO_ADAP           IDS_UI_NCPA_BASE+155
#define IDS_FOUND_REG_QUERY_FAIL      IDS_UI_NCPA_BASE+156
#define IDS_FOUND_OUT_OF_MEMORY       IDS_UI_NCPA_BASE+157
#define IDS_FOUND_ENUM_FAILED           IDS_UI_NCPA_BASE+158
#define IDS_QUERY_INTERNAL_ERR       IDS_UI_NCPA_BASE+159
#define IDS_FACTS_DLG_FAILURE           IDS_UI_NCPA_BASE+160
#define IDS_FACTS_CONVERT_FAILURE     IDS_UI_NCPA_BASE+161
#define IDS_FACTS_ADAPT_FAILURE       IDS_UI_NCPA_BASE+162
#define IDS_FACTS_PROD_FAILURE       IDS_UI_NCPA_BASE+163
#define IDS_QUERY_REGISTRY_FAILURE    IDS_UI_NCPA_BASE+164
#define IDS_INSTALL_NO_PARMS_FILE     IDS_UI_NCPA_BASE+165
#define IDS_INSTALL_UNSUPPORTED       IDS_UI_NCPA_BASE+166
#define IDS_NCPA_NAME_CLOSE           IDS_UI_NCPA_BASE+167
#define IDS_NCPA_NAME_CONTINUE        IDS_UI_NCPA_BASE+168
#define IDS_NCPA_NAME_EXIT_SETUP      IDS_UI_NCPA_BASE+169
#define IDS_NCPA_NAME_STRING            IDS_UI_NCPA_BASE+170
#define IDS_NCPA_INFO_STRING            IDS_UI_NCPA_BASE+171
#define IDS_NCPA_ALL_COMPONENTS       IDS_UI_NCPA_BASE+172
#define IDS_NCPA_FILE_NOT_FOUND       IDS_UI_NCPA_BASE+173
#define IDS_NCPA_KEY_NAME_NOT_FOUND   IDS_UI_NCPA_BASE+174
#define IDS_NCPA_VALUE_NAME_NOT_FOUND IDS_UI_NCPA_BASE+175
#define IDS_NCPA_FILE_NOT_FOUND_STR   IDS_UI_NCPA_BASE+176
#define IDS_NCPA_NAME_STRING_SETTINGS IDS_UI_NCPA_BASE+177

#define IDS_DOMWNT_HELP_1             IDS_UI_NCPA_BASE+201
#define IDS_DOMWNT_HELP_2             IDS_UI_NCPA_BASE+202
#define IDS_DOMWNT_HELP_3             IDS_UI_NCPA_BASE+203
#define IDS_DOMWNT_HELP_4             IDS_UI_NCPA_BASE+204
#define IDS_DOMWNT_HELP_5             IDS_UI_NCPA_BASE+205

#define IDS_DOMJOIN_HELP_1            IDS_UI_NCPA_BASE+211
#define IDS_DOMJOIN_HELP_2            IDS_UI_NCPA_BASE+212
#define IDS_DOMJOIN_HELP_3            IDS_UI_NCPA_BASE+213

#define IDS_DOMLANNT_HELP_1           IDS_UI_NCPA_BASE+221
#define IDS_DOMLANNT_HELP_2           IDS_UI_NCPA_BASE+222
#define IDS_DOMLANNT_HELP_3           IDS_UI_NCPA_BASE+223

#define IDS_DOMMGR_CANT_FIND_DC1      IDS_UI_NCPA_BASE+300
#define IDS_DOMMGR_CANT_CONNECT_DC    IDS_UI_NCPA_BASE+305
#define IDS_DOMMGR_CANT_ADD_DC_ACCT1  IDS_UI_NCPA_BASE+310
#define IDS_DOMMGR_CANT_JOIN_DOMAIN1  IDS_UI_NCPA_BASE+315
#define IDS_DOMMGR_CREDENTIAL_CONFLICT IDS_UI_NCPA_BASE+317

#define IDS_EXIT_SETUP_WARNING1       IDS_UI_NCPA_BASE+320

#define IDS_EXIT_SETUP_LANMAN1        IDS_UI_NCPA_BASE+323

#define IDS_DOMMGR_CANT_CONNECT_DC_PW IDS_UI_NCPA_BASE+325

#define IDS_DOMMGR_INV_USER_NAME      IDS_UI_NCPA_BASE+330
#define IDS_DOMMGR_INV_COMPUTER_NAME  IDS_UI_NCPA_BASE+331
#define IDS_DOMMGR_INV_PASSWORD       IDS_UI_NCPA_BASE+332
#define IDS_DOMMGR_INV_DOMAIN_NAME    IDS_UI_NCPA_BASE+333
#define IDS_DOMMGR_INV_NAME           IDS_UI_NCPA_BASE+334
#define IDS_DOMMGR_NAME_CONFLICT_DOMAIN  IDS_UI_NCPA_BASE+335
#define IDS_DOMMGR_NAME_CONFLICT_WKGROUP IDS_UI_NCPA_BASE+336
#define IDS_DOMMGR_INV_WORKGROUP_NAME    IDS_UI_NCPA_BASE+337

#define IDS_NCPA_OVERLAY1             IDS_UI_NCPA_BASE+340
#define IDS_NCPA_OVERLAY2             IDS_UI_NCPA_BASE+341
#define IDS_NCPA_OVERLAY3             IDS_UI_NCPA_BASE+342

#define IDS_NCPA_CANT_LOCK_CONFIG     IDS_UI_NCPA_BASE+350
#define IDS_NCPA_CANT_LEAVE_DOMAIN    IDS_UI_NCPA_BASE+351
#define IDS_NCPA_CANT_CHNG_COMP_NAME  IDS_UI_NCPA_BASE+352

#define IDS_NCPA_COMP_INF_VALUE_NF    IDS_UI_NCPA_BASE+353
#define IDS_NCPA_COMP_OPT_VALUE_NF    IDS_UI_NCPA_BASE+354
#define IDS_NCPA_COMP_KEY_NF          IDS_UI_NCPA_BASE+355

#define IDS_NCPA_SCMGR_CANT_OPEN      IDS_UI_NCPA_BASE+360
#define IDS_NCPA_SCMGR_CANT_ENUM      IDS_UI_NCPA_BASE+361
#define IDS_NCPA_SCMGR_CANT_LOCK      IDS_UI_NCPA_BASE+362
#define IDS_NCPA_SCMGR_CANT_UNLOCK    IDS_UI_NCPA_BASE+363
#define IDS_NCPA_SCMGR_CANT_CREATE    IDS_UI_NCPA_BASE+364
#define IDS_NCPA_SCMGR_CANT_CHANGE    IDS_UI_NCPA_BASE+365
#define IDS_NCPA_SCMGR_CANT_QUERY     IDS_UI_NCPA_BASE+366
#define IDS_NCPA_SCMGR_CANT_START     IDS_UI_NCPA_BASE+367
#define IDS_NCPA_SCMGR_CANT_DELETE    IDS_UI_NCPA_BASE+368
#define IDS_NCPA_SCMGR_CANT_SET_SEC   IDS_UI_NCPA_BASE+369

#define IDS_NCPA_USER_SHOULD_REBOOT   IDS_UI_NCPA_BASE+382
#define IDS_NCPA_REBOOT_API_FAILED    IDS_UI_NCPA_BASE+383

#define IDS_COMP_NAME_CHANGE_WARN1    IDS_UI_NCPA_BASE+390

#define IDS_DOMAIN_LEFT_STANDALONE1   IDS_UI_NCPA_BASE+400

#define IDS_NCPA_CANT_QUERY_DOMAIN    IDS_UI_NCPA_BASE+410
#define IDS_NCPA_CANT_OPEN_SVCCTRL    IDS_UI_NCPA_BASE+411

#define IDS_NCPA_DEFAULT_WORKGROUP    IDS_UI_NCPA_BASE+412
#define IDS_NCPA_DEFAULT_DOMAIN       IDS_UI_NCPA_BASE+413

#define IDS_NCPA_BAD_INSTALLATION     IDS_UI_NCPA_BASE+420

/*  Some of these messages are reported through the DireWarning */
/*  mechanism which concatenates errors, so a message number    */
/*  is skipped between each.                                    */

#define IDS_NCPA_REMOVE_WARNING         IDS_UI_NCPA_BASE+422
#define IDS_NCPA_SETUP_ALREADY_RUNNING  IDS_UI_NCPA_BASE+424
#define IDS_NCPA_COMP_NAME_CHNG_ONLY    IDS_UI_NCPA_BASE+426
#define IDS_NCPA_MACHINE_ACCT_INVALID_S   IDS_UI_NCPA_BASE+428
#define IDS_NCPA_DOMAIN_CHANGE_FAILED   IDS_UI_NCPA_BASE+430
#define IDS_NCPA_DOMAIN_NOT_NT          IDS_UI_NCPA_BASE+432
#define IDS_NCPA_SERVICE_BIND_FAILED    IDS_UI_NCPA_BASE+434
#define IDS_NCPA_SERVICE_DEPEND_FAILED  IDS_UI_NCPA_BASE+436
#define IDS_NCPA_BLT_INIT_FAILED        IDS_UI_NCPA_BASE+438
#define IDS_NCPA_MACHINE_ACCT_NOT_FOUND IDS_UI_NCPA_BASE+440
#define IDS_NCPA_BINDING_READ_ONLY      IDS_UI_NCPA_BASE+442
#define IDS_NCPA_DOMAIN_CHANGE_FAILED_2 IDS_UI_NCPA_BASE+444
#define IDS_NCPA_MACHINE_ACCT_INVALID_W   IDS_UI_NCPA_BASE+446

#define IDS_NCPA_HELP_FILE_NAME         IDS_UI_NCPA_BASE+460

#define IDS_NCPA_WELCOME_TO_DOMAIN      IDS_UI_NCPA_BASE+462

#define IDS_NCPA_WELCOME_TO_WORKGROUP   IDS_UI_NCPA_BASE+464
#define IDS_NCPA_COMPUTERNAME_CHANGED   IDS_UI_NCPA_BASE+465

#define IDS_NCPA_WELCOME_TO_STANDALONE  IDS_UI_NCPA_BASE+466

#define IDS_NCPA_BINDINGS_REVIEW_LOST   IDS_UI_NCPA_BASE+468

#define IDS_NCPA_DOMAIN_EXISTS          IDS_UI_NCPA_BASE+470

#define IDS_NCPA_CHG_NETLOGON_STARTTYPE IDS_UI_NCPA_BASE+471

#define IDS_NCPA_CANT_CHG_BDC_DOMAIN1    IDS_UI_NCPA_BASE+473
#define IDS_NCPA_CANT_CHG_BDC_DOMAIN2    IDS_UI_NCPA_BASE+474

#define IDS_NCPA_COMPUTER_EXISTS         IDS_UI_NCPA_BASE+476

#define IDS_NCPA_DETECT_EXPORT_MISSING  IDS_UI_NCPA_BASE+480
#define IDS_NCPA_DETECT_NO_DLLS         IDS_UI_NCPA_BASE+482
#define IDS_NCPA_DTMGR_FAILED           IDS_UI_NCPA_BASE+484
#define IDS_NCPA_DTDLG_FAILED           IDS_UI_NCPA_BASE+486
#define IDS_NCPA_DTSVC_NOT_FOUND        IDS_UI_NCPA_BASE+488
#define IDS_NCPA_DTSVC_FAILED           IDS_UI_NCPA_BASE+490
#define IDS_NCPA_QURY_RESOURCE_NF       IDS_UI_NCPA_BASE+492
#define IDS_NCPA_QURY_CONSULT_FAILED    IDS_UI_NCPA_BASE+494
#define IDS_NCPA_QURY_QUERY_FAILED      IDS_UI_NCPA_BASE+496

#define IDS_NCPA_DETECT_VERIFY_OK       IDS_UI_NCPA_BASE+498

#define IDS_NCPA_OFFSCREEN_RUN_INF      IDS_UI_NCPA_BASE+520
#define IDS_NCPA_OFFSCREEN_RUN_INSTALL  IDS_UI_NCPA_BASE+522

#define IDS_NCPA_CONFLICT_IRQ           IDS_UI_NCPA_BASE+530
#define IDS_NCPA_CONFLICT_IOADDR        IDS_UI_NCPA_BASE+532
#define IDS_NCPA_CONFLICT_MEMADDR       IDS_UI_NCPA_BASE+534
#define IDS_NCPA_CONFLICT_DMA           IDS_UI_NCPA_BASE+536

#define IDS_NCPA_DETECT_BUS_ENUM_FAILED IDS_UI_NCPA_BASE+538

#define IDS_NCPA_QUERY_INSTALL_NETWORK  IDS_UI_NCPA_BASE+540
#define IDS_NCPA_PROCESS_LAUNCH         IDS_UI_NCPA_BASE+542
#define IDS_NCPA_WARN_CONFIG_DIRTY      IDS_UI_NCPA_BASE+543
#define IDS_NCPA_LANAMAP_MISMATCH       IDS_UI_NCPA_BASE+545
#define IDS_DUPLICATE_LANANUM           (IDS_UI_NCPA_BASE+556)
#define IDS_INCORRECT_LANANUM           (IDS_UI_NCPA_BASE+558)
#define IDS_NO_NETBIOS_INFO             (IDS_UI_NCPA_BASE+565)

// DLC - HP Printer port name
#define IDS_HP_MONITOR_NAME             (IDS_UI_NCPA_BASE+566)

// browser stuff

#define IDS_INCORRECT_INPUT_TYPE        (IDS_UI_NCPA_BASE+510)

#define IDS_JAZZ_BUS                     (IDS_UI_NCPA_BASE+580)
#define IDS_ISA_BUS                      (IDS_UI_NCPA_BASE+581)
#define IDS_EISA_BUS                     (IDS_UI_NCPA_BASE+582)
#define IDS_MCA_BUS                      (IDS_UI_NCPA_BASE+583)
#define IDS_NCPA_NETWORK                 (IDS_UI_NCPA_BASE+584)
#define IDS_NCPA_PRINT                   (IDS_UI_NCPA_BASE+585)
#define IDS_NCPA_NWLINK                  (IDS_UI_NCPA_BASE+586)

/*   Help Context IDs  */

#define HC_NCPA_DOMAIN_WINNT           HC_UI_NCPA_BASE+200
#define HC_NCPA_DOMAIN_LANMANNT        HC_UI_NCPA_BASE+210
#define HC_NCPA_DOMLMN_RENAME          HC_UI_NCPA_BASE+215
#define HC_NCPA_MPR_ORDER              HC_UI_NCPA_BASE+220
#define HC_NCPA_MAIN_DIALOG            HC_UI_NCPA_BASE+230
#define HC_NCPA_BINDINGS_DIALOG        HC_UI_NCPA_BASE+240
#define HC_NCPA_COMPUTERNAME           HC_UI_NCPA_BASE+291
#define HC_NCPA_LANANUM                HC_UI_NCPA_BASE+300
#define HC_NCPA_BROWSER                HC_UI_NCPA_BASE+310
#define HC_NCPA_WARN_CFG_DIRTY         HC_UI_NCPA_BASE+340
#define HC_NCPA_INSTALL_NETWORK        HC_UI_NCPA_BASE+330
