/******************************************************************************

txtpalet.h

    Author:  Jess Botts

    This file contains the text mode palette.  Most of the entries are 0
    because they are not used.  The first 8 entries are used for all
    background colors and normal intensity foregound colors.  Background
    colors are displayed at normal intensity only.  The 8 entries that
    begin at the 56th entry are used for high intensity foreground colors.

    Each entry consists of 3 values, 1 for each color gun.

******************************************************************************/

/*
 * Copyright (c) 1995 FirePower Systems, Inc.
 * DO NOT DISTRIBUTE without permission
 *
 * $RCSfile: txtpalet.h $
 * $Revision: 1.4 $
 * $Date: 1996/01/11 07:14:21 $
 * $Locker:  $
 */

UCHAR
        TextPalette[] =
            {                                                         /*
                                                                         Line
             R   G   B      R   G   B      R   G   B      R   G   B      Index
                                                                      */

// all background colors and normal intensity foregound colors

             0,  0,  0,     0,  0, 32,     0, 32,  0,     0, 32, 32,   //   0
            32,  0,  0,    32,  0, 32,    32, 32,  0,    32, 32, 32,

             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,

// high intensity foreground colors

            16, 16, 16,     0,  0, 63,     0, 63,  0,     0, 63, 63,   // 56
            63,  0,  0,    63,  0, 63,    63, 63,  0,    63, 63, 63,

             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,   // 64
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,    // 128
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,    // 192
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0,
             0,  0,  0,     0,  0,  0,     0,  0,  0,     0,  0,  0
            };

/*****************************************************************************/
