/*++

Copyright (c) 1994  Microsoft Corporation

Module Name:

    MissyId.h

Abstract:

    This module contains definitions related to the Missy dialoges
    and corresponding controls.

Author:

    Jim Kelly (JimK) 22-Mar-1995

Revision History:

    None.


--*/

//
// Unused
//

#define  MISSYP_UNUSED_1                                    100

//
// Common Buttons
//

#define MISSYP_ID_BUTTON_HELP                               101
#define MISSYP_ID_TEXT_SECURITY_LEVEL                       102
#define MISSYP_ID_BUTTON_APPLY                              103
#define MISSYP_ID_BUTTON_YES                                104
#define MISSYP_ID_BUTTON_NO                                 105


///////////////////////////////////////////////////////////////
//                                                           //
//  SYSTEM ACCESS area dialog control IDs                    //
//                                                           //
///////////////////////////////////////////////////////////////

#define MISSYP_ID_DLG_AREA_SYSACC                           200
#define MISSYP_ID_DLG_HINT_LOGON_CACHE                      201
#define MISSYP_ID_DLG_HINT_UNLOCK_WORKSTATION               202
#define MISSYP_ID_DLG_HINT_SHUTDOWN_SYSTEM                  203
#define MISSYP_ID_DLG_HINT_LAST_USERNAME                    204
#define MISSYP_ID_DLG_HINT_LEGAL_NOTICE                     205

#define MISSYP_ID_DLG_WARNING_AUTOLOGON                     209


#define MISSYP_ID_DLG_ITEM_LOGON_CACHE                      210
#define MISSYP_ID_DLG_ITEM_UNLOCK_WORKSTATION               211
#define MISSYP_ID_DLG_ITEM_SHUTDOWN_SYSTEM                  212
#define MISSYP_ID_DLG_ITEM_LAST_USERNAME                    213
#define MISSYP_ID_DLG_ITEM_LEGAL_NOTICE                     214


#define MISSYP_ID_SYMBOL_STRONGER                           216
#define MISSYP_ID_SYMBOL_WEAKER                             217
#define MISSYP_ID_SYMBOL_RECOMMEND                          218

//
// Logon cache
//

#define MISSYP_ID_SPIN_LOGCAC_APPLY                         220
#define MISSYP_ID_TEXT_LOGCAC_APPLY                         221
#define MISSYP_ID_TEXT_LOGCAC_CURRENT                       222
#define MISSYP_ID_TEXT_LOGCAC_RECOMMEND                     223
#define MISSYP_ID_BUTTON_LOGCAC_HINT                        224
#define MISSYP_ID_TEXT_LOGCAC_APPLY_LINE                    225
#define MISSYP_ID_RECOMMEND_LOGON_CACHE                     226

//
// Unlock Workstation
//

#define MISSYP_ID_RADIO_UNLOCK_ANYONE                       230
#define MISSYP_ID_RADIO_UNLOCK_ADMIN                        231
#define MISSYP_ID_BUTTON_UNLOCK_HINT                        232
#define MISSYP_ID_RECOMMEND_UNLOCK_ANYONE                   233
#define MISSYP_ID_RECOMMEND_UNLOCK_ADMIN                    234

//
// Shutdown System
//

#define MISSYP_ID_RADIO_SHUTDOWN_ANYONE                     240
#define MISSYP_ID_RADIO_SHUTDOWN_LOGGED_ON                  241
#define MISSYP_ID_RADIO_SHUTDOWN_OPERS                      242
#define MISSYP_ID_RADIO_SHUTDOWN_ADMIN                      243
#define MISSYP_ID_RECOMMEND_SHUTDOWN_ANYONE                 244
#define MISSYP_ID_RECOMMEND_SHUTDOWN_LOGGED_ON              245
#define MISSYP_ID_RECOMMEND_SHUTDOWN_OPERS                  246
#define MISSYP_ID_RECOMMEND_SHUTDOWN_ADMIN                  247
#define MISSYP_ID_BUTTON_SHUTDOWN_HINT                      248

//
// Display Last Username At Logon
//

#define MISSYP_ID_RADIO_LASTNAME_DISPLAY                    250
#define MISSYP_ID_RADIO_LASTNAME_DONT_DISPLAY               251
#define MISSYP_ID_RECOMMEND_LASTNAME_DISPLAY                252
#define MISSYP_ID_RECOMMEND_LASTNAME_DONT_DISPLAY           253
#define MISSYP_ID_BUTTON_LASTNAME_HINT                      254


//
// Display Legal Notice At Logon
//

#define MISSYP_ID_RADIO_LEGAL_NOTICE_NONE                   260
#define MISSYP_ID_RADIO_LEGAL_NOTICE                        261
#define MISSYP_ID_EDIT_LEGAL_NOTICE_CAPTION                 262
#define MISSYP_ID_EDIT_LEGAL_NOTICE_BODY                    263
#define MISSYP_ID_RECOMMEND_LEGAL_NOTICE_NONE               264
#define MISSYP_ID_RECOMMEND_LEGAL_NOTICE                    265
#define MISSYP_ID_TEXT_LEGAL_NOTICE_TITLE_BAR               266
#define MISSYP_ID_TEXT_LEGAL_NOTICE_BODY                    267
#define MISSYP_ID_BUTTON_LEGAL_NOTICE_HINT                  268


//
// Popup dialog control IDs
//

#define MISSYP_ID_DLG_POPUP                                 300
#define MISSYP_ID_TEXT_POPUP_MESSAGE                        301


//
// Yes/No Popup dialog controls
//

#define MISSYP_ID_DLG_YES_NO_POPUP                          320
#define MISSYP_ID_TEXT_YES_NO_POPUP_MESSAGE                 321






