/******************************Module*Header*******************************\
* Module Name: ledwnd.h
*
* Public interface to the LED window implementation
*
*
* Created: dd-mm-93
* Author:  Stephen Estrop [StephenE]
*
* Copyright (c) 1993 Microsoft Corporation
\**************************************************************************/

BOOL
InitLEDClass(
    HINSTANCE hInst
    );

LRESULT CALLBACK
LEDWndProc(
    HWND hwnd,
    UINT  message,
    WPARAM wParam,
    LPARAM lParam
    );

BOOL
Init_SJE_TextClass(
    HINSTANCE hInst
    );


#ifdef DECLARE_DATA
BYTE cr[] = {
    0x8D, 0x8B, 0x8F, 0x89, 0xA9, 0xA5, 0xC5, 0xC3,
    0xA8, 0xD9, 0xE6, 0xEA, 0xF5, 0xE8, 0xFC, 0xAF,
    0xF4, 0xF4, 0xE4, 0xF6, 0xF8, 0xFA, 0xE6, 0xF2,
    0xFC, 0xB9, 0xF8, 0xE2, 0xBC, 0xB0, 0x93, 0x95,
    0xAD, 0xAB, 0xF1, 0xD7, 0xC1, 0xD5, 0xCE, 0xC2,
    0xC6, 0x89, 0xEF, 0xD8, 0xD8, 0xDF, 0xC1, 0xDF,
    0xBD, 0xBB, 0xBF, 0xB9, 0xB9, 0xBF, 0x9B, 0x97,
    0xCC, 0xDC, 0xC9, 0xCF, 0xD9, 0xD9, 0x9E, 0xDD,
    0xB9, 0xE1, 0xEF, 0xCE, 0xCE, 0xC8, 0xCC, 0x8D,
    0xA7, 0xA1, 0xA4, 0xEB, 0x8E, 0xBF, 0xAB, 0xBC,
    0xB5, 0xBC, 0xB3, 0xBD, 0xBA, 0xD8, 0xDC, 0x96,
    0xB6, 0xBD, 0xA8, 0xBE, 0xAB, 0xFD, 0x99, 0xAA,
    0x99, 0xEC, 0xE8, 0xA2, 0x8A, 0x91, 0x8E, 0x88,
    0x86, 0x90, 0xCA, 0xBB, 0x84, 0x84, 0x82, 0x83,
    0x99, 0x81, 0x81, 0xFE, 0xFE, 0xBF, 0x99, 0x9F,
    0x96, 0xD9, 0xAB, 0x8E, 0x95, 0x9E, 0x95, 0xF2,
    0x8A, 0xCC, 0xEB, 0xE8, 0xE1, 0xA5, 0xD2, 0xF5,
    0xE1, 0xEA, 0xE1, 0xEE, 0xFE, 0x80, 0x84, 0x82,
    0x9A, 0x9C, 0x98, 0xBE, 0xB4, 0xF8, 0xF7, 0xF9,
    0xF9, 0xFE, 0xFF, 0xFF, 0xBC, 0xFF, 0xE7, 0xBF,
    0x8D, 0xAC, 0xA8, 0xAE, 0xAE, 0xE9, 0xC7, 0xD2,
    0xDA, 0xC0, 0xCF, 0x8B, 0xEB, 0xDF, 0xC7, 0xC9,
    0xD6, 0xD8, 0xC6, 0xDB, 0xC7, 0xB8, 0xBC, 0xBA,
    0xB2, 0xB4, 0xB0, 0x96, 0x9C, 0xCD, 0xCC, 0xD0,
    0xA4, 0xB4, 0xA1, 0xB7, 0xAD, 0xAA, 0xA8, 0xE7,
    0xE5, 0xC4, 0xC0, 0xC6, 0xC6, 0x8C, 0xA2, 0xA6,
    0xA3, 0xA5, 0xB3, 0xBA, 0xA6, 0xF5, 0x94, 0xB6,
    0xB6, 0xB2, 0xA9, 0xD6, 0xD6, 0x9E, 0xAC, 0xB6,
    0x93, 0x95, 0x8B, 0x82, 0x8A, 0x8A, 0xC6, 0xB7,
    0x81, 0x8C, 0x98, 0x99, 0x95, 0xE0, 0xE4, 0xE2,
    0xFA, 0xFC, 0xF8, 0xDE, 0xD4, 0xBA, 0x84, 0x9E,
    0x9F, 0x90, 0x94, 0x9A, 0x90, 0xDD, 0xAB, 0xB6,
    0xA0, 0xC5, 0xE7, 0xF0, 0xED, 0xE2, 0xE8, 0xA7,
    0xA5, 0x84, 0x80, 0x86, 0x86, 0xDF, 0xE7, 0xEC,
    0xFB, 0xB1, 0xC6, 0xE6, 0xE6, 0xFB, 0xF3, 0xE5,
    0x95, 0x93, 0x97, 0x91, 0x91, 0x97, 0x93, 0x95,
    0x8D, 0x81, 0xC6, 0xCC, 0xC7, 0xD0, 0xCB, 0xC2,
    0xC6, 0xDD, 0xCB, 0xDF, 0xC5, 0xC2, 0xC0, 0x8F,
    0x9D, 0xBC, 0xB8, 0xBE, 0xBE, 0xF9, 0xD7, 0xC2,
    0xCA, 0xD8, 0x9A, 0xE8, 0xD4, 0xD8, 0xCE, 0xCF,
    0xA1, 0xB3, 0xA6, 0xCE, 0xCE, 0x82, 0xA7, 0xBE,
    0xA4, 0xAC, 0xEA, 0x9B, 0xA5, 0xAE, 0xA5, 0xAA,
    0xBE, 0xDC, 0xD8, 0xDE, 0xDE, 0xD8, 0xDC, 0xFA,
    0xF8, 0xB8, 0xBE, 0xB6, 0xB5, 0xB3, 0xB7, 0xAC,
    0x94, 0x93, 0x83, 0x97, 0x8D, 0x93, 0x83, 0xC7,
    0xC5, 0xE4, 0xE0, 0xE6, 0xE6, 0xA1, 0x8F, 0x9A,
    0x82, 0x98, 0x97, 0xD3, 0xB7, 0x99, 0x97, 0x8E,
    0x8C, 0x96, 0x94, 0xF6, 0xF6, 0xB7, 0x97, 0x93,
    0xEC, 0xA1, 0xCA, 0xE6, 0xE5, 0xE9, 0x8B, 0x8D,
    0x85, 0x83, 0x87, 0x81, 0xA1, 0xAD, 0xEA, 0xEA,
    0xF4, 0xF8, 0xF1, 0xF2, 0xE0, 0xF0, 0xF2, 0xB7,
    0xEC, 0xF6, 0xBA, 0xB6, 0x91, 0x97, 0x93, 0x95,
    0xF0, 0xC4, 0xCC, 0xC6, 0xC8, 0xCA, 0xD6, 0xC2,
    0x88, 0xEB, 0xD8, 0xC4, 0xC3, 0xC0, 0xCB, 0xDD,
    0xBD, 0xBB, 0xBF, 0xB9, 0xB9, 0xBF, 0xBB, 0xBD,
    0xB5, 0xB3, 0xB7, 0xB1, 0xB1, 0xB7, 0xFE, 0xB2,
    0xCA, 0xDB
};
#endif

