/******************************Module*Header*******************************\
* Module Name: dl_proc.c
*
* Display list compilation routines.
*
* Created: 12-26-1995
* Author: Hock San Lee [hockl]
*
* Copyright (c) 1995 Microsoft Corporation
\**************************************************************************/

/* Client Side Display List Compilation Procedure Table */

#include "precomp.h"
#pragma hdrstop

#include "glclt.h"
#include "exttable.h"

GLCLTPROCTABLE ListCompCltProcTable =
{

/* Number of function entries in the table */

     sizeof(GLDISPATCHTABLE) / sizeof(PROC),

/* gl Entry points */
  {
     glcltNewList                ,
     glcltEndList                ,
     __gllc_CallList               ,
     __gllc_CallLists              ,
     glcltDeleteLists            ,
     glcltGenLists               ,
     __gllc_ListBase               ,
     __gllc_Begin                  ,
     __gllc_Bitmap                 ,
     __gllc_Color3b                ,
     __gllc_Color3bv               ,
     __gllc_Color3d                ,
     __gllc_Color3dv               ,
     __gllc_Color3f                ,
     __gllc_Color3fv               ,
     __gllc_Color3i                ,
     __gllc_Color3iv               ,
     __gllc_Color3s                ,
     __gllc_Color3sv               ,
     __gllc_Color3ub               ,
     __gllc_Color3ubv              ,
     __gllc_Color3ui               ,
     __gllc_Color3uiv              ,
     __gllc_Color3us               ,
     __gllc_Color3usv              ,
     __gllc_Color4b                ,
     __gllc_Color4bv               ,
     __gllc_Color4d                ,
     __gllc_Color4dv               ,
     __gllc_Color4f                ,
     __gllc_Color4fv               ,
     __gllc_Color4i                ,
     __gllc_Color4iv               ,
     __gllc_Color4s                ,
     __gllc_Color4sv               ,
     __gllc_Color4ub               ,
     __gllc_Color4ubv              ,
     __gllc_Color4ui               ,
     __gllc_Color4uiv              ,
     __gllc_Color4us               ,
     __gllc_Color4usv              ,
     __gllc_EdgeFlag               ,
     __gllc_EdgeFlagv              ,
     __gllc_End                    ,
     __gllc_Indexd                 ,
     __gllc_Indexdv                ,
     __gllc_Indexf                 ,
     __gllc_Indexfv                ,
     __gllc_Indexi                 ,
     __gllc_Indexiv                ,
     __gllc_Indexs                 ,
     __gllc_Indexsv                ,
     __gllc_Normal3b               ,
     __gllc_Normal3bv              ,
     __gllc_Normal3d               ,
     __gllc_Normal3dv              ,
     __gllc_Normal3f               ,
     __gllc_Normal3fv              ,
     __gllc_Normal3i               ,
     __gllc_Normal3iv              ,
     __gllc_Normal3s               ,
     __gllc_Normal3sv              ,
     __gllc_RasterPos2d            ,
     __gllc_RasterPos2dv           ,
     __gllc_RasterPos2f            ,
     __gllc_RasterPos2fv           ,
     __gllc_RasterPos2i            ,
     __gllc_RasterPos2iv           ,
     __gllc_RasterPos2s            ,
     __gllc_RasterPos2sv           ,
     __gllc_RasterPos3d            ,
     __gllc_RasterPos3dv           ,
     __gllc_RasterPos3f            ,
     __gllc_RasterPos3fv           ,
     __gllc_RasterPos3i            ,
     __gllc_RasterPos3iv           ,
     __gllc_RasterPos3s            ,
     __gllc_RasterPos3sv           ,
     __gllc_RasterPos4d            ,
     __gllc_RasterPos4dv           ,
     __gllc_RasterPos4f            ,
     __gllc_RasterPos4fv           ,
     __gllc_RasterPos4i            ,
     __gllc_RasterPos4iv           ,
     __gllc_RasterPos4s            ,
     __gllc_RasterPos4sv           ,
     __gllc_Rectd                  ,
     __gllc_Rectdv                 ,
     __gllc_Rectf                  ,
     __gllc_Rectfv                 ,
     __gllc_Recti                  ,
     __gllc_Rectiv                 ,
     __gllc_Rects                  ,
     __gllc_Rectsv                 ,
     __gllc_TexCoord1d             ,
     __gllc_TexCoord1dv            ,
     __gllc_TexCoord1f             ,
     __gllc_TexCoord1fv            ,
     __gllc_TexCoord1i             ,
     __gllc_TexCoord1iv            ,
     __gllc_TexCoord1s             ,
     __gllc_TexCoord1sv            ,
     __gllc_TexCoord2d             ,
     __gllc_TexCoord2dv            ,
     __gllc_TexCoord2f             ,
     __gllc_TexCoord2fv            ,
     __gllc_TexCoord2i             ,
     __gllc_TexCoord2iv            ,
     __gllc_TexCoord2s             ,
     __gllc_TexCoord2sv            ,
     __gllc_TexCoord3d             ,
     __gllc_TexCoord3dv            ,
     __gllc_TexCoord3f             ,
     __gllc_TexCoord3fv            ,
     __gllc_TexCoord3i             ,
     __gllc_TexCoord3iv            ,
     __gllc_TexCoord3s             ,
     __gllc_TexCoord3sv            ,
     __gllc_TexCoord4d             ,
     __gllc_TexCoord4dv            ,
     __gllc_TexCoord4f             ,
     __gllc_TexCoord4fv            ,
     __gllc_TexCoord4i             ,
     __gllc_TexCoord4iv            ,
     __gllc_TexCoord4s             ,
     __gllc_TexCoord4sv            ,
     __gllc_Vertex2d               ,
     __gllc_Vertex2dv              ,
     __gllc_Vertex2f               ,
     __gllc_Vertex2fv              ,
     __gllc_Vertex2i               ,
     __gllc_Vertex2iv              ,
     __gllc_Vertex2s               ,
     __gllc_Vertex2sv              ,
     __gllc_Vertex3d               ,
     __gllc_Vertex3dv              ,
     __gllc_Vertex3f               ,
     __gllc_Vertex3fv              ,
     __gllc_Vertex3i               ,
     __gllc_Vertex3iv              ,
     __gllc_Vertex3s               ,
     __gllc_Vertex3sv              ,
     __gllc_Vertex4d               ,
     __gllc_Vertex4dv              ,
     __gllc_Vertex4f               ,
     __gllc_Vertex4fv              ,
     __gllc_Vertex4i               ,
     __gllc_Vertex4iv              ,
     __gllc_Vertex4s               ,
     __gllc_Vertex4sv              ,
     __gllc_ClipPlane              ,
     __gllc_ColorMaterial          ,
     __gllc_CullFace               ,
     __gllc_Fogf                   ,
     __gllc_Fogfv                  ,
     __gllc_Fogi                   ,
     __gllc_Fogiv                  ,
     __gllc_FrontFace              ,
     __gllc_Hint                   ,
     __gllc_Lightf                 ,
     __gllc_Lightfv                ,
     __gllc_Lighti                 ,
     __gllc_Lightiv                ,
     __gllc_LightModelf            ,
     __gllc_LightModelfv           ,
     __gllc_LightModeli            ,
     __gllc_LightModeliv           ,
     __gllc_LineStipple            ,
     __gllc_LineWidth              ,
     __gllc_Materialf              ,
     __gllc_Materialfv             ,
     __gllc_Materiali              ,
     __gllc_Materialiv             ,
     __gllc_PointSize              ,
     __gllc_PolygonMode            ,
     __gllc_PolygonStipple         ,
     __gllc_Scissor                ,
     __gllc_ShadeModel             ,
     __gllc_TexParameterf          ,
     __gllc_TexParameterfv         ,
     __gllc_TexParameteri          ,
     __gllc_TexParameteriv         ,
     __gllc_TexImage1D             ,
     __gllc_TexImage2D             ,
     __gllc_TexEnvf                ,
     __gllc_TexEnvfv               ,
     __gllc_TexEnvi                ,
     __gllc_TexEnviv               ,
     __gllc_TexGend                ,
     __gllc_TexGendv               ,
     __gllc_TexGenf                ,
     __gllc_TexGenfv               ,
     __gllc_TexGeni                ,
     __gllc_TexGeniv               ,
     glcltFeedbackBuffer         ,
     glcltSelectBuffer           ,
     glcltRenderMode             ,
     __gllc_InitNames              ,
     __gllc_LoadName               ,
     __gllc_PassThrough            ,
     __gllc_PopName                ,
     __gllc_PushName               ,
     __gllc_DrawBuffer             ,
     __gllc_Clear                  ,
     __gllc_ClearAccum             ,
     __gllc_ClearIndex             ,
     __gllc_ClearColor             ,
     __gllc_ClearStencil           ,
     __gllc_ClearDepth             ,
     __gllc_StencilMask            ,
     __gllc_ColorMask              ,
     __gllc_DepthMask              ,
     __gllc_IndexMask              ,
     __gllc_Accum                  ,
     __gllc_Disable                ,
     __gllc_Enable                 ,
     glcltFinish                 ,
     glcltFlush                  ,
     __gllc_PopAttrib              ,
     __gllc_PushAttrib             ,
     __gllc_Map1d                  ,
     __gllc_Map1f                  ,
     __gllc_Map2d                  ,
     __gllc_Map2f                  ,
     __gllc_MapGrid1d              ,
     __gllc_MapGrid1f              ,
     __gllc_MapGrid2d              ,
     __gllc_MapGrid2f              ,
     __gllc_EvalCoord1d            ,
     __gllc_EvalCoord1dv           ,
     __gllc_EvalCoord1f            ,
     __gllc_EvalCoord1fv           ,
     __gllc_EvalCoord2d            ,
     __gllc_EvalCoord2dv           ,
     __gllc_EvalCoord2f            ,
     __gllc_EvalCoord2fv           ,
     __gllc_EvalMesh1              ,
     __gllc_EvalPoint1             ,
     __gllc_EvalMesh2              ,
     __gllc_EvalPoint2             ,
     __gllc_AlphaFunc              ,
     __gllc_BlendFunc              ,
     __gllc_LogicOp                ,
     __gllc_StencilFunc            ,
     __gllc_StencilOp              ,
     __gllc_DepthFunc              ,
     __gllc_PixelZoom              ,
     __gllc_PixelTransferf         ,
     __gllc_PixelTransferi         ,
     glcltPixelStoref            ,
     glcltPixelStorei            ,
     __gllc_PixelMapfv             ,
     __gllc_PixelMapuiv            ,
     __gllc_PixelMapusv            ,
     __gllc_ReadBuffer             ,
     __gllc_CopyPixels             ,
     glcltReadPixels             ,
     __gllc_DrawPixels             ,
     glcltGetBooleanv            ,
     glcltGetClipPlane           ,
     glcltGetDoublev             ,
     glcltGetError               ,
     glcltGetFloatv              ,
     glcltGetIntegerv            ,
     glcltGetLightfv             ,
     glcltGetLightiv             ,
     glcltGetMapdv               ,
     glcltGetMapfv               ,
     glcltGetMapiv               ,
     glcltGetMaterialfv          ,
     glcltGetMaterialiv          ,
     glcltGetPixelMapfv          ,
     glcltGetPixelMapuiv         ,
     glcltGetPixelMapusv         ,
     glcltGetPolygonStipple      ,
     glcltGetString              ,
     glcltGetTexEnvfv            ,
     glcltGetTexEnviv            ,
     glcltGetTexGendv            ,
     glcltGetTexGenfv            ,
     glcltGetTexGeniv            ,
     glcltGetTexImage            ,
     glcltGetTexParameterfv      ,
     glcltGetTexParameteriv      ,
     glcltGetTexLevelParameterfv ,
     glcltGetTexLevelParameteriv ,
     glcltIsEnabled              ,
     glcltIsList                 ,
     __gllc_DepthRange             ,
     __gllc_Frustum                ,
     __gllc_LoadIdentity           ,
     __gllc_LoadMatrixf            ,
     __gllc_LoadMatrixd            ,
     __gllc_MatrixMode             ,
     __gllc_MultMatrixf            ,
     __gllc_MultMatrixd            ,
     __gllc_Ortho                  ,
     __gllc_PopMatrix              ,
     __gllc_PushMatrix             ,
     __gllc_Rotated                ,
     __gllc_Rotatef                ,
     __gllc_Scaled                 ,
     __gllc_Scalef                 ,
     __gllc_Translated             ,
     __gllc_Translatef             ,
     __gllc_Viewport               ,
     __gllc_ArrayElement           ,
     __gllc_BindTexture            ,
     glcltColorPointer             ,
     glcltDisableClientState       ,
     __gllc_DrawArrays             ,
     __gllc_DrawElements           ,
     glcltEdgeFlagPointer          ,
     glcltEnableClientState        ,
     glcltIndexPointer             ,
     __gllc_Indexub                ,
     __gllc_Indexubv               ,
     glcltInterleavedArrays        ,
     glcltNormalPointer            ,
     __gllc_PolygonOffset          ,
     glcltTexCoordPointer          ,
     glcltVertexPointer            ,
     glcltAreTexturesResident      ,
     __gllc_CopyTexImage1D         ,
     __gllc_CopyTexImage2D         ,
     __gllc_CopyTexSubImage1D      ,
     __gllc_CopyTexSubImage2D      ,
     glcltDeleteTextures           ,
     glcltGenTextures              ,
     glcltGetPointerv              ,
     glcltIsTexture                ,
     __gllc_PrioritizeTextures     ,
     __gllc_TexSubImage1D          ,
     __gllc_TexSubImage2D          ,
     glcltPopClientAttrib          ,
     glcltPushClientAttrib         ,
  }

};

GLEXTPROCTABLE ListCompExtProcTable =
{
    /* Number of function entries in the table */
    sizeof(GLEXTDISPATCHTABLE) / sizeof(PROC),

    /* gl EXT Entry points */
  {
      __gllc_ColorTableEXT,
      __gllc_ColorSubTableEXT,
      glcltGetColorTableEXT,
      glcltGetColorTableParameterivEXT,
      glcltGetColorTableParameterfvEXT,
  }
};
